package client;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Properties;

import remote.CallerRemote;

import javax.rmi.PortableRemoteObject;
import motoSample.ejb.Hello;
import motoSample.ejb.HelloHome;

import motoSample.ejb.User;
import motoSample.ejb.UserHome;


public class TestRemoteClientA
  {
      public static void main(String ar[]) throws Exception
       {
          Context context=null;
       try
         {
                Properties props = new Properties();
                props.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
                props.put(Context.PROVIDER_URL, "remote://localhost:4447");
                props.put(Context.SECURITY_PRINCIPAL, "ejbuser");
                props.put(Context.SECURITY_CREDENTIALS, "ejbpassword");
                context = new InitialContext(props);
	        System.out.println("\n\tGot initial Context: "+context);
         }
       catch (Exception e)
         {
                e.printStackTrace();
          }

         // Lookup Format will be
         // <app-name>/<module-name>/<distinct-name>/<bean-name>!<fully-qualified-classname-of-the-remote-interface>

         CallerRemote remote=(CallerRemote)context.lookup("TestRemoteEJBEAR/remoteEJB//CallerBean!remote.CallerRemote");
         System.out.println("remote.testMethod >>>> " + remote.testMethod("hello beautiful world!!!"));

        
        
            Object ref  = context.lookup("/moto-ejb-svr1/Hello!motoSample.ejb.HelloHome");
            System.out.println("Got reference \n");

            // Get a reference from this to the Bean's Home interface
            HelloHome home = (HelloHome)
                PortableRemoteObject.narrow (ref, HelloHome.class);

            // Create an hello object from the Home interface
            Hello hello = home.create();
            System.out.println("msg from hellloo bean : " + hello.sayHello("helloooo sweeetieeeee!!"));
            /*
            */
        
	        //		java:global/moto-ejb2-entity/User!motoSample.ejb.UserHome

            Object ref2 = context.lookup("/moto-ejb2-entity/User!motoSample.ejb.UserHome");
            System.out.println("Got reference 2\n");

            // Get a reference from this to the Bean's Home interface
            UserHome uhome = (UserHome)
                PortableRemoteObject.narrow (ref2, UserHome.class);

            //User usr1 = uhome.create("dddd", "", "");
            //System.out.println("user name : " + usr1.getUserName());
            User usr2 = uhome.findByPrimaryKey("dmotooka");
            System.out.println("user name : " + usr2.getUserName());
            System.out.println("pwd : " + usr2.getPassword());
        /*
        */

              
       }
  }
