package motoSample.client;

import javax.naming.*;
import java.util.Hashtable;
import javax.rmi.PortableRemoteObject;
import java.util.Properties;
import javax.naming.Context;

//import javax.ejb.*;



///you will need the interface on both compile time and run time!!!!
import motoSample.ejb.Hello;
import motoSample.ejb.HelloHome;

public class HelloClientBean
{
    Hello hello = null;
    HelloHome home = null;

    public HelloClientBean() {

    }

    /**
        This method does all the work. It creates an instance of the hello EJB on
     the EJB server, and calls its `sayHello()' method, then prints
     the result the returned String.
     */
    public void startup () {
            System.out.println("start up...\n");
        // Set up the naming provider; this may not always be necessary, depending
        // on how your Java system is configured.
        
        /*
        System.setProperty("java.naming.factory.initial",
                           "org.jnp.interfaces.NamingContextFactory");
        */
        /*
        System.setProperty("java.naming.factory.initial",
                           "org.jboss.ejb.client.naming");
        System.setProperty("java.naming.provider.url",
                           "localhost:1099");
        */
        
        // A single `try' block is not an ideal way  to do exception handling, but it
        // is easier to read code without all the catch blocks
            System.out.println("try block...\n");
        try
        {
            Context context=null;
            Properties props = new Properties();
            props.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
            props.put(Context.PROVIDER_URL, "remote://localhost:4447");
            props.put(Context.SECURITY_PRINCIPAL, "ejbuser");
            props.put(Context.SECURITY_CREDENTIALS, "ejbpassword");
            context = new InitialContext(props);
            System.out.println("Got context \n");

            Object ref  = context.lookup("/moto-ejb-svr1/Hello!motoSample.ejb.HelloHome");
            System.out.println("Got reference \n");

            // Get a reference from this to the Bean's Home interface
            home = (HelloHome)
                PortableRemoteObject.narrow (ref, HelloHome.class);

            // Create an hello object from the Home interface
            hello = home.create();
            System.out.println("hello created... \n");
            /*
            */

        }   catch(Exception e)
        {
            System.out.println(e.toString());
        }
    }
    
    public String sayGreeting(String greeting) {
        String output = new String("");
        /*
        */
        try {
            System.out.println("bean hellow..!!!");
            output += hello.sayHello(greeting);
        }  catch(Exception e)    {
            System.out.println(e.toString());
        }
        return(output);
    }
}

